#include <bits/stdc++.h>
using namespace std;

const long long MX=5e5+10;
int a[MX],in[MX];

int clc(int l,int r)
{
    for(int i=l;i<=r;i++)
    {
        in[i]=1;
    }

    int sm=0;
    for(int i=l;i<=r;i++)
    {
        sm+=a[i];
        if(sm<0)
        {
            in[i]=0;
            sm++;
        }
    }

    sm=0;
    for(int i=r;i>=l;i--)
    {
        sm+=a[i]*in[i];
        if(sm<0)
        {
            in[i]=0;
            sm++;
        }
    }

    int ans=0;

    for(int i=l;i<=r;i++)
    {
        ans+=in[i];
    }

    return ans;
}
int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n,m;
    cin>>n>>m;

    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }

    while(m--)
    {
        int t;
        cin>>t;

        if(t==1)
        {
            int in;
            cin>>in;

            a[in]*=-1;
        }
        else
        {
            int l,r;
            cin>>l>>r;
            
            cout<<clc(l,r)<<"\n";
        }
    }

    return 0;
}